<?php
/**
 * @package Sj Categories Slider for JoomShopping
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2013 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

class JFormFieldLbcategory extends JFormFieldList
{
	/**
	* Element type
	*
	* @access	protected
	* @var		string
	*/
	protected $type = 'lbcategory';
	
	function getInput()
	{
		
		$catmodel = GFactory::get('site::com.listbingo.model.categories');	
		$lists['catlist'] = $catmodel->getCategoryTree();
		return self::optionlist(array ('name' => $this->name,'selectalloptions'=>true,'attribs' => 
		array ('size' => 10, 'multiple' => 'multiple'), 'options' => $lists['catlist'], 'selected' => $this->value,
		'prompt' => 'All Category' ));
	}
	
	public function optionlist($config = array())
	{

		$config = new GConfig($config);
		$config->append(array(
			'options' 	=> array(),
			'name'   	=> 'id',
			'attribs'	=> array('size' => 1),
			'selected'	=> null, 
		  	'deselect'  => false,
		  	'prompt'  => JText::_('Select'),
			'translate'	=> false,
			'selectalloptions'=> false,
			'dselectdefaultvalue' => 0
		));

		$name    = $config->name;
		$attribs = GHelperArray::toString($config->attribs);

		$html = array();
		$html[] = '<select name="'. $name .'" '. $attribs .'>';

		if($config->deselect) {
			$html[] = '<option value="'.$config->dselectdefaultvalue.'">'.$config->prompt.'</option>';
		}

		foreach($config->options as $option)
		{
			$value  = $option->value;
			$text   = $config->translate ? JText::_( $option->text ) : $option->text;

			$extra = '';
			if((isset($option->disable) && $option->disable) || (!empty($option->children)) && $config->selectalloptions == false) {
				$extra .= 'disabled="disabled"';
			}

			if(isset($option->attribs)) {
				$extra .= ' '.GHelperArray::toString($option->attribs);;
			}
				
			if(!is_null($config->selected))
			{
				if ($config->selected instanceof GConfig)
				{
					foreach ($config->selected as $selected)
					{
						$sel = is_object( $selected ) ? $selected->value : $selected;
						if ($value == $sel)
						{
							$extra .= 'selected="selected"';
							break;
						}
					}
				}
				else $extra .= ((string) $value == $config->selected ? ' selected="selected"' : '');
			}

			$html[] = '<option value="'. $value .'" '. $extra .'>' . $text . '</option>';
		}

		$html[] = '</select>';

		return implode(PHP_EOL, $html);
	}
	
}
?>
